// DCM module
// DCMclkrxȊÕNbN𐶐

`default_nettype none
`timescale 1ns / 1ps

module dcm_module (sysclk, reset, ddr2_clk, ddr2_clkb, clk, clk90, clkx, clk270, clk1_16, dcm_lock);
	`include "./ddr2_cont_parameters.vh"
	input sysclk, reset;
	output [QUANTITY_OF_CLK_OUTPUT-1 : 0] ddr2_clk, ddr2_clkb;
	output clk, clk90, clkx, clk270, clk1_16;
	output dcm_lock;
	
	wire sysclk, reset;
	wire [QUANTITY_OF_CLK_OUTPUT-1 : 0] ddr2_clk, ddr2_clkb;
	wire clk, clk90, clkx, clk270, clk1_16;
	wire dcm_lock;
	
	wire vcc, gnd;
	wire clk_bufg, clk_node, clk90_node, clkx_node, clk270_node, clk1_16_node, dcm1_lock;
	wire clkx_bufg, clk90_bufg, clk270_bufg, clk1_16_bufg;
	wire locked_ext;
	wire clk200_node, clk200_bufg;
	wire dcm200_lock, dcm_inst1_reset;
	wire clk100_node, clk100_bufg;
	
	assign vcc = 1'b1;
	assign gnd = 1'b0;

	DCM DCM_200_INST (
		.CLKIN(sysclk),
		.CLKFB(clk100_bufg),
		.DSSEN(gnd),
		.PSINCDEC(gnd),
		.PSEN(gnd),
		.PSCLK(gnd),
		.RST(gnd), // ZbgƂDCM̃bNOȂ悤gndɂĂ
		.CLK0(clk100_node),
		.CLK90(),
		.CLK180(),
		.CLK270(),
		.CLK2X(clk200_node),
		.CLK2X180(),
		.CLKDV(),
		.CLKFX(),
		.CLKFX180(),
		.LOCKED(dcm200_lock),
		.PSDONE(),
		.STATUS()
	);
	defparam DCM_200_INST.CLKIN_PERIOD = 10.0;
	defparam DCM_200_INST.DLL_FREQUENCY_MODE = "LOW";
	defparam DCM_200_INST.DUTY_CYCLE_CORRECTION = "TRUE";
	defparam DCM_200_INST.CLKDV_DIVIDE = 16.0;
	defparam DCM_200_INST.PHASE_SHIFT = 0;
	defparam DCM_200_INST.CLKOUT_PHASE_SHIFT = "NONE";
	defparam DCM_200_INST.STARTUP_WAIT = "FALSE";
	// defparam DCM_200_INST.FACTORY_JF = 16'hFFFF;
	
	BUFG BUFG_CLK_100(
		.I(clk100_node),
		.O(clk100_bufg)
	);
	BUFG BUFG_CLK_200(
		.I(clk200_node),
		.O(clk200_bufg)
	);
	
	assign dcm_inst1_reset = ~dcm200_lock;
	DCM DCM_INST1 (
		.CLKIN(clk200_bufg),
		.CLKFB(clk_bufg),
		.DSSEN(gnd),
		.PSINCDEC(gnd),
		.PSEN(gnd),
		.PSCLK(gnd),
		.RST(dcm_inst1_reset), // ZbgƂDCM̃bNOȂ悤gndɂĂ
		.CLK0(clk_node),
		.CLK90(clk90_node),
		.CLK180(clkx_node),
		.CLK270(clk270_node),
		.CLK2X(),
		.CLK2X180(),
		.CLKDV(clk1_16_node),
		.CLKFX(),
		.CLKFX180(),
		.LOCKED(dcm1_lock),
		.PSDONE(),
		.STATUS()
	);
	defparam DCM_INST1.CLKIN_PERIOD = 5.0;
	defparam DCM_INST1.DLL_FREQUENCY_MODE = "LOW";
	defparam DCM_INST1.DUTY_CYCLE_CORRECTION = "TRUE";
	defparam DCM_INST1.CLKDV_DIVIDE = 16.0;
	defparam DCM_INST1.PHASE_SHIFT = 0;
	defparam DCM_INST1.CLKOUT_PHASE_SHIFT = "NONE";
	defparam DCM_INST1.STARTUP_WAIT = "FALSE";
	// defparam DCM_INST1.FACTORY_JF = 16'hFFFF;
	
	BUFG CLK_BUFG_INST (
		.I(clk_node),
		.O(clk_bufg)
	);
	assign clk = clk_bufg;
	
	BUFG CLK90_BUFG_INST (
		.I(clk90_node),
		.O(clk90_bufg)
	);
	assign clk90 = clk90_bufg;
	
	assign clkx = ~clk_bufg;
	assign clk270 = ~clk90_bufg;
	assign clk1_16 = clk1_16_node;
	assign clkx_bufg = ~clk_bufg;
	
	generate
	genvar i;
		for(i=0; i<=QUANTITY_OF_CLK_OUTPUT-1; i=i+1) begin: DDR2_CLK
			FDDRRSE DDR2CLK_INST (
				.Q(ddr2_clk[i]),
				.C0(clk_bufg),
				.C1(clkx_bufg),
				.CE(vcc),
				.D0(vcc),
				.D1(gnd),
				.R(gnd),
				.S(gnd)
			);
			FDDRRSE DDR2CLKB_INST (
				.Q(ddr2_clkb[i]),
				.C0(clk_bufg),
				.C1(clkx_bufg),
				.CE(vcc),
				.D0(gnd),
				.D1(vcc),
				.R(gnd),
				.S(gnd)
			);
		end
	endgenerate
	
	assign dcm_lock = dcm1_lock;
endmodule
