// DDR2 SDRAM Controller
// XAPP253ƔrăAhXFIFO{āA[hƃCg̃AhXFIFO1ɂB邱ƂɂāA[hƃCgEANZX̗D揇ʂ̖B
// DDR2ł4o[Xgœ삷Bwrdata_fifo2f[^̕łB̂wrdata_fifoɘA2f[^
// 
// 2006.12.14

`default_nettype none
`timescale 1ns / 1ps

module ddr2_sdram_cont (clk_in, clk_out, reset, input_data, input_mask, read_write, output_data, input_address, addr_fifo_wren, wrdata_fifo_wren, addr_fifo_full, wrdata_fifo_full, rddata_valid, initialize_end, ddr2_clk, ddr2_clkb, ddr2_cke, ddr2_dqs, ddr2_dqs_n, ddr2_dq, ddr2_csb, ddr2_rasb, ddr2_casb, ddr2_web, ddr2_dm, ddr2_ba, ddr2_address, ddr2_odt);
	`include "./ddr2_cont_parameters.vh"
	
	input clk_in; // NbN
	output clk_out; // NbNo
	input reset;
	input [INTERFACE_DATA_WIDTH-1 : 0] input_data;
	input [INTERFACE_MASK_WIDTH-1 : 0] input_mask;
	input read_write;
	output [INTERFACE_DATA_WIDTH-1 : 0] output_data;
	input [USER_INPUT_ADDRESS_WIDTH-1 : 0] input_address;
	input addr_fifo_wren; // AhXpFIFȌ݃Cl[u
	input wrdata_fifo_wren; // FIFȌ݃Cl[u
	output addr_fifo_full;
	output wrdata_fifo_full;
	output rddata_valid; // ǂݏof[^L
	output initialize_end;
	output [QUANTITY_OF_CLK_OUTPUT-1 : 0] ddr2_clk;
	output [QUANTITY_OF_CLK_OUTPUT-1 : 0] ddr2_clkb;
	output ddr2_cke;
	output [DDR2_DQS_DM_WIDTH-1 : 0] ddr2_dqs;
	output [DDR2_DQS_DM_WIDTH-1 : 0] ddr2_dqs_n;
	inout [DDR2_DATA_WIDTH-1 : 0] ddr2_dq;
	output ddr2_csb;
	output ddr2_rasb;
	output ddr2_casb;
	output ddr2_web;
	output [DDR2_DQS_DM_WIDTH-1 : 0] ddr2_dm;
	output [1:0] ddr2_ba;
	output [DDR2_ADDRESS_WIDTH-1 : 0] ddr2_address;
	output ddr2_odt;
	
	wire clk_in; // NbN
	wire clk_out; // NbNo
	wire reset;
	wire [INTERFACE_DATA_WIDTH-1 : 0] input_data;
	wire [INTERFACE_MASK_WIDTH-1 : 0] input_mask;
	wire read_write;
	wire [INTERFACE_DATA_WIDTH-1 : 0] output_data;
	wire [USER_INPUT_ADDRESS_WIDTH-1 : 0] input_address;
	wire addr_fifo_wren; // AhXpFIFȌ݃Cl[u
	wire wrdata_fifo_wren; // FIFȌ݃Cl[u
	wire addr_fifo_full;
	wire wrdata_fifo_full;
	wire rddata_valid; // ǂݏof[^L
	wire initialize_end;
	wire [QUANTITY_OF_CLK_OUTPUT-1 : 0] ddr2_clk;
	wire [QUANTITY_OF_CLK_OUTPUT-1 : 0] ddr2_clkb;
	wire ddr2_cke;
	wire [DDR2_DQS_DM_WIDTH-1 : 0] ddr2_dqs;
	wire [DDR2_DQS_DM_WIDTH-1 : 0] ddr2_dqs_n;
	wire [DDR2_DATA_WIDTH-1 : 0] ddr2_dq;
	wire ddr2_csb;
	wire ddr2_rasb;
	wire ddr2_casb;
	wire ddr2_web;
	wire [DDR2_DQS_DM_WIDTH-1 : 0] ddr2_dm;
	wire [1:0] ddr2_ba;
	wire [DDR2_ADDRESS_WIDTH-1 : 0] ddr2_address;
	wire ddr2_odt;
	
	wire clk, clk90, clkx, clk270, clk1_16, dcm_lock;
	wire [USER_INPUT_ADDRESS_WIDTH-1 : 0] address, next_address;
	wire read_writex, next_read_writex;
	wire addr_fifo_empty, addr_fifo_almost_empty, addr_fifo_rden;
	wire wrdata_fifo_empty, wrdata_fifo_almost_empty, wrdata_fifo_rden;
	wire dqs_enable, dqs_reset, write_timing, read_timing, burst_read;
	wire [INTERFACE_DATA_WIDTH-1 : 0] wrdata_fifo_data;
	wire [INTERFACE_MASK_WIDTH-1 : 0] wrdata_fifo_mask;
	wire wrdata_fifo_almost_full;
	wire rddata_fifo_rden;
	wire rddata_fifo_empty ,rddata_fifo_almost_empty;
	wire [INTERFACE_DATA_WIDTH-1 : 0] rddata_fifo_data;
	wire rddata_fifo_wren, rddata_fifo_full, rddata_fifo_almost_full;
	wire ie;
	reg iel;
	
	dcm_module dcm_module_inst (
		.sysclk(clk_in),
		.reset(reset),
		.ddr2_clk(ddr2_clk),
		.ddr2_clkb(ddr2_clkb),
		.clk(clk),
		.clk90(clk90),
		.clkx(clkx),
		.clk270(clk270),
		.clk1_16(clk1_16),
		.dcm_lock(dcm_lock)
	);
	
	controller controller_inst (
		.clk(clk),
		.clkx(clkx),
		.clk1_16(clk1_16),
		.reset(reset),
		.dcm_lock(dcm_lock),
		.address(address),
		.read_writex(read_writex),
		.next_address(next_address),
		.next_read_writex(next_read_writex),
		.addr_fifo_rden(addr_fifo_rden),
		.addr_fifo_empty(addr_fifo_empty),
		.addr_fifo_almost_empty(addr_fifo_almost_empty),
		.wrdata_fifo_empty(wrdata_fifo_empty),
		.wrdata_fifo_almost_empty(wrdata_fifo_almost_empty),
		.wrdata_fifo_rden(wrdata_fifo_rden),
		.ddr2_rasb(ddr2_rasb),
		.ddr2_casb(ddr2_casb),
		.ddr2_web(ddr2_web),
		.ddr2_ba(ddr2_ba),
		.ddr2_address(ddr2_address),
		.ddr2_cke(ddr2_cke),
		.ddr2_csb(ddr2_csb),
		.dqs_enable(dqs_enable),
		.dqs_reset(dqs_reset),
		.write_timing(write_timing),
		.read_timing(read_timing),
		.burst_read(burst_read),
		.initialize_end(ie)
	);
	always @(posedge clk) begin
		if (reset==1'b1)
			iel <= 1'b0;
		else
			iel <= ie;
	end
	assign initialize_end = iel;
	
	read_data_module read_data_module_inst (
		.reset(reset),
		.clk(clk),
		.clkx(clkx),
		.read_timing(read_timing),
		.burst_read(burst_read),
		.rddata_fifo_data(rddata_fifo_data),
		.rddata_fifo_wren(rddata_fifo_wren),
		.rddata_fifo_full(rddata_fifo_full),
		.rddata_fifo_almost_full(rddata_fifo_almost_full),
		.ddr2_dq(ddr2_dq),
		.ddr2_dqs(ddr2_dqs)
	);
	
	write_data_module write_data_module_inst (
		.reset(reset),
		.clk(clk),
		.clk90(clk90),
		.clkx(clkx),
		.clk270(clk270),
		.wrdata_fifo_rden(wrdata_fifo_rden),
		.wrdata_fifo_data(wrdata_fifo_data),
		.wrdata_fifo_mask(wrdata_fifo_mask),
		.dqs_enable(dqs_enable),
		.dqs_reset(dqs_reset),
		.ddr2_dqs(ddr2_dqs),
		.ddr2_dqs_n(ddr2_dqs_n),
		.ddr2_dq(ddr2_dq),
		.ddr2_dm(ddr2_dm)
	);
	
	addr_fifo addr_fifo_inst (
		.clk(clk),
		.reset(reset),
		.din(input_address),
		.read_write(read_write),
		.wr_en(addr_fifo_wren),
		.rd_en(addr_fifo_rden),
		.dout(address),
		.rw_out(read_writex),
		.full(addr_fifo_full),
		.empty(addr_fifo_empty),
		.next_dout(next_address),
		.next_rw_out(next_read_writex),
		.almost_empty(addr_fifo_almost_empty),
		.almost_full()
	);
	
	wrdata_fifo wrdata_fifo_inst (
		.clk(clk),
		.reset(reset),
		.din(input_data),
		.maskin(input_mask),
		.rd_en(wrdata_fifo_rden),
		.wr_en(wrdata_fifo_wren),
		.full(wrdata_fifo_full),
		.almost_full(wrdata_fifo_almost_full),
		.empty(wrdata_fifo_empty),
		.almost_empty(wrdata_fifo_almost_empty),
		.dout(wrdata_fifo_data),
		.maskout(wrdata_fifo_mask)
	);
	
	rddata_fifo rddata_fifo_inst (
		.clk(clk),
		.reset(reset),
		.din(rddata_fifo_data),
		.rd_en(rddata_fifo_rden),
		.wr_en(rddata_fifo_wren),
		.full(rddata_fifo_full),
		.almost_full(rddata_fifo_almost_full),
		.empty(rddata_fifo_empty),
		.almost_empty(rddata_fifo_almost_empty),
		.dout(output_data)
	);
	assign rddata_fifo_rden = (rddata_fifo_empty==1'b0) ? 1'b1 : 1'b0; // emptyłȂ́A[hf[^ǂݏo
	assign rddata_valid = rddata_fifo_rden;
	assign clk_out = clk;
	assign ddr2_odt = 1'b0; // ODT̓fBXG[u
endmodule
