// rddata_fifo
// ǂݏof[^Ă

`default_nettype none
`timescale 1ns / 1ps

module rddata_fifo (clk, reset, din, rd_en, wr_en, full, almost_full, empty, almost_empty, dout);
	`include "./ddr2_cont_parameters.vh"

	input clk;
	input reset;
	input [INTERFACE_DATA_WIDTH-1 : 0] din;
	input rd_en;
	input wr_en;
	output full;
	output almost_full;
	output empty;
	output almost_empty;
	output [INTERFACE_DATA_WIDTH-1 : 0] dout;
	
	wire clk;
	wire reset;
	wire [INTERFACE_DATA_WIDTH-1 : 0] din;
	wire rd_en;
	wire wr_en;
	wire full;
	wire almost_full;
	wire empty;
	wire almost_empty;
	wire [INTERFACE_DATA_WIDTH-1 : 0] dout;
	
	reg [3:0] wp, rp;
	wire [INTERFACE_DATA_WIDTH-1 : 0] data_node;
	reg [INTERFACE_DATA_WIDTH-1 : 0] out_data;
	reg outff_flag;
	wire fifo_full, fifo_empty;
	wire inner_rd_en;
	wire we;
	
	generate
	genvar i;
		for (i=INTERFACE_DATA_WIDTH-1; i>=0; i=i-1) begin: RDDATA_RAM
			RAM16X1D #(
				.INIT(16'h0000) // Initial contents of RAM
			) RAM16_INST (
				.DPO(data_node[i]),
				.SPO(),
				.A0(wp[0]),
				.A1(wp[1]),
				.A2(wp[2]),
				.A3(wp[3]),
				.D(din[i]),
				.DPRA0(rp[0]),
				.DPRA1(rp[1]),
				.DPRA2(rp[2]),
				.DPRA3(rp[3]),
				.WCLK(clk),
				.WE(we)
			);
		end
	endgenerate
	assign we = wr_en && (~fifo_full);
	
	always @(posedge clk) begin // wp, rp
		if (reset==1'b1) begin
			wp <= 0;
			rp <= 0;
		end else begin
			if (wr_en==1'b1 && fifo_full==1'b0) // wr_en1ŁAFIFOtłȂƂɏ
				wp <= wp + 1;
			if (inner_rd_en==1'b1 && fifo_empty==1'b0) // rd_en1ŁAFIFOemptyoȂɓǂݏo
				rp <= rp + 1;
		end
	end
	assign fifo_full = (rp-1==wp) ? 1'b1 : 1'b0; // rp1wptB1GggȂ傤Ȃ
	assign full = fifo_full;
	assign almost_full = (rp-2==wp) ? 1'b1 : 1'b0;
	assign fifo_empty = (rp==wp) ? 1'b1 : 1'b0; // rp = wp̎AFIFO͋
	
	always @(posedge clk) begin // out_data
		if (reset==1'b1)
			out_data <= 0;
		else if (fifo_empty==1'b0 && ~(rd_en==1'b0 && outff_flag==1'b1))
		// FIFOłȂAoutff1œǂݏoȂȊOoutffFIFO̓eǂݏo
			out_data <= data_node;
	end
	assign inner_rd_en = (fifo_empty==1'b0 && ~(rd_en==1'b0 && outff_flag==1'b1)) ? 1'b1 : 1'b0;
	
	always @(posedge clk) begin
		if (reset==1'b1)
			outff_flag <= 1'b0;
		else if (inner_rd_en==1'b1)
			outff_flag <= 1'b1;
		else if (rd_en==1'b1)
			outff_flag <= 1'b0;
	end
	assign dout = out_data;
	assign empty = ~outff_flag;
	assign almost_empty = (outff_flag==1'b0 || (outff_flag==1'b1 && fifo_empty==1'b1)) ? 1'b1 : 1'b0;
endmodule

	