// Read Data Module
// ReadDDR SDRAM̃f[^󂯂
// DQzxAZbgAbvԂ𑍌vĎ3/4炷Bclknot clkŃf[^TvłB
// DDR24o[Xgpread_timing1NbNL΂

`default_nettype none
`timescale 1ns / 1ps

module read_data_module(reset, clk, clkx, read_timing, burst_read, rddata_fifo_data, rddata_fifo_wren, rddata_fifo_full, rddata_fifo_almost_full, ddr2_dq, ddr2_dqs);
	`include "./ddr2_cont_parameters.vh"

	input reset;
	input clk;
	input clkx;
	input read_timing;
	input burst_read;
	output [INTERFACE_DATA_WIDTH-1 : 0] rddata_fifo_data;
	output rddata_fifo_wren;
	input rddata_fifo_full;
	input rddata_fifo_almost_full;
	
	input [DDR2_DATA_WIDTH-1 : 0] ddr2_dq;
	input [DDR2_DQS_DM_WIDTH-1 : 0] ddr2_dqs;
	
	wire reset;
	wire clk;
	wire clkx;
	wire read_timing;
	wire burst_read;
	wire [INTERFACE_DATA_WIDTH-1 : 0] rddata_fifo_data;
	wire rddata_fifo_wren;
	wire rddata_fifo_full;
	wire rddata_fifo_almost_full;
	wire [DDR2_DATA_WIDTH-1 : 0] ddr2_dq;
	wire [DDR2_DQS_DM_WIDTH-1 : 0] ddr2_dqs;
	
	reg rddata_fifo_wren_node0, rddata_fifo_wren_node1;
	reg [DDR2_DATA_WIDTH-1 : 0] dq_rise, dq_fall;
	reg [DDR2_DATA_WIDTH-1 : 0] dq_rise_1d, dq_fall_1d;
	reg [DDR2_DATA_WIDTH-1 : 0] dq_rise_2d, dq_fall_2d;
	reg read_timing_1d;
	
	// ͗pDDRWX^̐
	always @(posedge clk) begin // DQIOBDDRWX^𐄒肳
		if (reset)
			dq_rise <= 0;
		else // オ
			dq_rise <= ddr2_dq;
	end
	always @(negedge clk) begin
		if (reset)
			dq_fall <= 0;
		else // 
			dq_fall <= ddr2_dq;
	end
	
	always @(posedge clkx) begin
		if (reset)
			read_timing_1d <= 1'b0;
		else
			read_timing_1d <= read_timing;
	end
	
	always @(posedge clkx) begin
		if (reset) begin
			dq_rise_1d <= 0;
			dq_fall_1d <= 0;
			rddata_fifo_wren_node0 <= 1'b0;
		end else begin
			dq_rise_1d <= dq_rise;
			dq_fall_1d <= dq_fall;
			rddata_fifo_wren_node0 <= read_timing;
		end
	end
	
	always @(posedge clk) begin // f[^clkxclkɏ悹
		if (reset) begin
			dq_rise_2d <= 0;
			dq_fall_2d <= 0;
			rddata_fifo_wren_node1 <= 1'b0;
		end else begin
			dq_rise_2d <= dq_rise_1d;
			dq_fall_2d <= dq_fall_1d;
			rddata_fifo_wren_node1 <= rddata_fifo_wren_node0;
		end
	end
			
			
	assign rddata_fifo_data = {dq_rise_2d, dq_fall_2d}; // ŏɏoĂ(rise)O[h(gEGfBAj
	assign rddata_fifo_wren = rddata_fifo_wren_node1;
endmodule

