// Write Data Module
// DQSDQADMo͂
// DQSclk90ɘAĕωB
// DQWRITsꂽclk(0xʑj̔NbNォCl[uɂB

`default_nettype none
`timescale 1ns / 1ps

module write_data_module (reset, clk, clk90, clkx, clk270, wrdata_fifo_rden, wrdata_fifo_data, wrdata_fifo_mask, dqs_enable, dqs_reset, ddr2_dqs, ddr2_dqs_n, ddr2_dq, ddr2_dm);
	`include "./ddr2_cont_parameters.vh"
	
	input reset;
	input clk;
	input clk90;
	input clkx;
	input clk270;
	input wrdata_fifo_rden;
	input [INTERFACE_DATA_WIDTH-1 : 0] wrdata_fifo_data;
	input [INTERFACE_MASK_WIDTH-1 : 0] wrdata_fifo_mask;
	input dqs_enable;
	input dqs_reset;
	
	output [DDR2_DQS_DM_WIDTH-1 : 0] ddr2_dqs;
	output [DDR2_DATA_WIDTH-1 : 0] ddr2_dq;
	output [DDR2_DQS_DM_WIDTH-1 : 0] ddr2_dqs_n;
	output [DDR2_DQS_DM_WIDTH-1 : 0] ddr2_dm;
	
	wire reset;
	wire clk;
	wire clk90;
	wire clkx;
	wire clk270;
	wire wrdata_fifo_rden;
	wire [INTERFACE_DATA_WIDTH-1 : 0] wrdata_fifo_data;
	wire [INTERFACE_MASK_WIDTH-1 : 0] wrdata_fifo_mask;
	wire dqs_enable;
	wire dqs_reset;
	reg [DDR2_DQS_DM_WIDTH-1 : 0] ddr2_dqs;
	reg [DDR2_DATA_WIDTH-1 : 0] ddr2_dq;
	reg [DDR2_DQS_DM_WIDTH-1 : 0] ddr2_dqs_n;
	wire [DDR2_DQS_DM_WIDTH-1 : 0] ddr2_dm;
	
	reg [INTERFACE_DATA_WIDTH-1 : 0] wrdata_1d, wrdata_2d;
	reg [INTERFACE_DATA_WIDTH-1 : 0] wrdata_3d;
	reg [INTERFACE_DATA_WIDTH/2-1 : 0] wrdata_3d_half;
	reg [INTERFACE_DATA_WIDTH/2-1 : 0] wrdata_4d_half;
	reg [INTERFACE_MASK_WIDTH-1 : 0] wrmask_1d, wrmask_2d;
	reg [INTERFACE_MASK_WIDTH-1 : 0] wrmask_3d;
	reg [INTERFACE_MASK_WIDTH/2-1 : 0] wrmask_3d_half;
	reg [INTERFACE_MASK_WIDTH/2-1 : 0] wrmask_4d_half;
	wire [DDR2_DATA_WIDTH-1 : 0] ddr2_out;
	wire [DDR2_DATA_WIDTH-1 : 0] out_tri;
	wire [DDR2_DQS_DM_WIDTH-1 : 0] dqs_out;
	wire [DDR2_DQS_DM_WIDTH-1 : 0] dqs_n_out;
	wire gnd, vcc;
	reg [DDR2_DQS_DM_WIDTH-1 : 0] dqs_enable_1d;
	reg [DDR2_DQS_DM_WIDTH*8-1 : 0] dqs_enable_2d;
	reg [DDR2_DQS_DM_WIDTH*8-1 : 0] dqs_enable_3d;
	reg [DDR2_DQS_DM_WIDTH-1 : 0] dqs_reset_1d;
	reg [DDR2_DQS_DM_WIDTH*8-1 : 0] dqs_reset_2d_dqtri, dqs_reset_3d_dqtri;
	reg [DDR2_DQS_DM_WIDTH-1 : 0] dqs_reset_2d;
	(* max_fanout="1" *) reg [DDR2_DQS_DM_WIDTH-1 : 0] dqs_reset_3d;
	(* max_fanout="1" *) reg [DDR2_DQS_DM_WIDTH-1 : 0] dqs_reset_d3d;
	reg [DDR2_DQS_DM_WIDTH-1 : 0] dqs_tri_enable_2dx;
	(* max_fanout="1" *) reg [DDR2_DQS_DM_WIDTH-1 : 0] dqs_tri_enable_3dx, dqs_tri_enable_d3dx;
	wire [DDR2_DQS_DM_WIDTH*8-1 : 0] not_dqs_enable_2d;
	wire [DDR2_DQS_DM_WIDTH*8-1 : 0] dq_tri_d0_b, dq_tri_d1_b;
	reg [DDR2_DQS_DM_WIDTH*8-1 : 0] dq_tri_d0, dq_tri_d1;
	
	assign gnd = 1'b0;
	assign vcc = 1'b1;
	
	always @ (posedge clk) begin
		if (reset==1'b1) begin
			wrdata_1d <= 0;
			wrmask_1d <= 0;
			wrdata_2d <= 0;
			wrmask_2d <= 0;
			wrdata_3d <= 0;
			wrmask_3d <= 0;
			wrdata_3d_half <= 0;
			wrmask_3d_half <= 0;
			wrdata_4d_half <= 0;
			wrmask_4d_half <= 0;
		end else begin
			wrdata_1d <= wrdata_fifo_data;
			wrmask_1d <= wrdata_fifo_mask;
			wrdata_2d <= wrdata_1d;
			wrmask_2d <= wrmask_1d;
			wrdata_3d <= wrdata_2d;
			wrmask_3d <= wrmask_2d;
			wrdata_3d_half <= wrdata_2d[INTERFACE_DATA_WIDTH-1 : INTERFACE_DATA_WIDTH/2];
			wrmask_3d_half <= wrmask_2d[INTERFACE_MASK_WIDTH-1 : INTERFACE_MASK_WIDTH/2];
			wrdata_4d_half <= wrdata_3d_half;
			wrmask_4d_half <= wrmask_4d_half;
		end
	end
	
	always @ (posedge clkx) begin : Dqs_Loop
		integer k;
		
		if (reset==1'b1) begin
			dqs_enable_1d <= 0;
			dqs_enable_2d <= 0;
			dqs_enable_3d <= 0;
			dqs_reset_1d <= 0;
			dqs_reset_2d_dqtri <= 0;
			dqs_reset_3d_dqtri <= 0;
		end else begin
			dqs_reset_1d <= {DDR2_DQS_DM_WIDTH{dqs_reset}};
			dqs_enable_1d <= {DDR2_DQS_DM_WIDTH{dqs_enable}};
			for (k=0; k<=DDR2_DATA_WIDTH-1; k=k+1) begin
				dqs_enable_2d[k] <= dqs_enable_1d[k/8];
				dqs_reset_2d_dqtri[k] <= dqs_reset_1d[k/8];
			end
			dqs_enable_3d <= dqs_enable_2d;
			dqs_reset_3d_dqtri <= dqs_reset_2d_dqtri;
		end
	end
	
	always @ (posedge clk90) begin
		if (reset==1'b1) begin
			dqs_reset_2d <= 0;
			dqs_reset_3d <= 0;
			dqs_reset_d3d <= 0;
		end else begin
			dqs_reset_2d <= dqs_reset_1d;
			dqs_reset_3d <= dqs_reset_2d;
			dqs_reset_d3d <= dqs_reset_2d;
		end
	end
	
	// Instantiate Output DDR registers
	generate
	genvar i;
		for (i=DDR2_DATA_WIDTH-1; i>=0; i=i-1) begin: WRDATA_OUT
			FDDRCPE WRDATA_DDR2_OUT (
				.Q(ddr2_out[i]),
				.D0(wrdata_3d[i]),
				.D1(wrdata_4d_half[i]),
				.C0(clk),
				.C1(clkx),
				.CE(dqs_enable_3d[i/8]),
				.CLR(reset),
				.PRE(gnd)
			);
		end
	endgenerate
	
	assign not_dqs_enable_2d = ~dqs_enable_2d;
	
	// Insantiate three-state DDR registers, gݍ킹HƊԂɍȂ̂ŁA񃉃b`
	assign dq_tri_d0_b = dqs_reset_2d_dqtri | not_dqs_enable_2d;
	assign dq_tri_d1_b = not_dqs_enable_2d;
	always @(posedge clkx) begin
		if (reset) begin
			dq_tri_d0 <= {DDR2_DQS_DM_WIDTH*8{1'b1}};
			dq_tri_d1 <= {DDR2_DQS_DM_WIDTH*8{1'b1}};
		end else begin
			dq_tri_d0 <= dq_tri_d0_b;
			dq_tri_d1 <= dq_tri_d1_b;
		end
	end
	
	generate
	genvar j;
		for (j=DDR2_DATA_WIDTH-1; j>=0; j=j-1) begin: WRDATA_TRI
			FDDRRSE WRDATA_DDR2_TRI (
				.Q(out_tri[j]),
				.D0(dq_tri_d0[j/8]), // DQS0ɂȂŏ̃NbN1Ȃ̂ŁAԍŏ̔NbNfBXG[u
				.D1(dq_tri_d1[j/8]),
				.C0(clk),
				.C1(clkx),
				.CE(vcc),
				.R(reset),
				.S(gnd)
			);
		end
	endgenerate
	
	// inferr the 3-State buffer
	always @ * begin :Ddr_Dq_Gen_Loop
		integer k;
		
		for (k=DDR2_DATA_WIDTH-1; k>=0; k=k-1) begin
			if (out_tri[k] == 1'b1)
				ddr2_dq[k] <= 1'bZ;
			else
				ddr2_dq[k] <= ddr2_out[k];
		end
	end
	
	// Instantiate Mask DDR registers
	generate
	genvar m;
		for (m=DDR2_DQS_DM_WIDTH-1; m>=0; m=m-1) begin: WRDATA_MASK
			FDDRCPE WRDATA_DDR2_MASK (
				.Q(ddr2_dm[m]),
				.D0(wrmask_3d[m]),
				.D1(wrmask_4d_half[m]),
				.C0(clk),
				.C1(clkx),
				.CE(dqs_enable_3d[m/8]),
				.CLR(reset),
				.PRE(gnd)
			);
		end
	endgenerate
	
	// Instantiate DQS DDR registers
	generate
	genvar n;
		for (n=DDR2_DQS_DM_WIDTH-1; n>=0; n=n-1) begin: WRDATA_DQS
			FDDRRSE WRDATA_DDR2_DQS (
				.Q(dqs_out[n]),
				.D0(vcc),
				.D1(gnd),
				.C0(clk90),
				.C1(clk270),
				.CE(vcc),
				.R(dqs_reset_3d[n]),
				.S(gnd)
			);
		end
	endgenerate
	
	always @ (posedge clk) begin
		if (reset==1'b1) begin
			dqs_tri_enable_2dx <= {DDR2_DQS_DM_WIDTH{1'b1}};
		end else begin
			dqs_tri_enable_2dx <= ~dqs_enable_2d[DDR2_DQS_DM_WIDTH-1 : 0];
		end
	end
	always @ (posedge clk) begin :Dqs_Reset_Loop // IOBɓ邽߂FDDRRSEƃZbg̘_킹
		integer k;
		
		for (k=DDR2_DQS_DM_WIDTH-1; k>=0; k=k-1) begin
			if (dqs_reset_3d[k]) begin
				// dqs_tri_enable_3dx[k] <= dqs_tri_enable_2dx[k];
				dqs_tri_enable_3dx[k] <= 1'b0;
			end else begin
				dqs_tri_enable_3dx[k] <= dqs_tri_enable_2dx[k];
			end
		end
	end
	always @ (posedge clk) begin :Dqs_n_Reset_Loop // IOBɓ邽߂FDDRRSEƃZbg̘_킹
		integer k;
		
		for (k=DDR2_DQS_DM_WIDTH-1; k>=0; k=k-1) begin
			if (dqs_reset_d3d[k]) begin
				dqs_tri_enable_d3dx[k] <= 1'b0;
			end else begin
				dqs_tri_enable_d3dx[k] <= dqs_tri_enable_2dx[k];
			end
		end
	end
	
	// inferr the 3-State buffer
	always @ * begin :Ddr_Dqs_Gen_Loop
		integer k;
		
		for (k=DDR2_DQS_DM_WIDTH-1; k>=0; k=k-1) begin
			if (dqs_tri_enable_3dx[k]==1'b1)
				ddr2_dqs[k] <= 1'bZ;
			else
				ddr2_dqs[k] <= dqs_out[k];
		end
	end
	
	// Instantiate DQS_N DDR registers(DQSƋtɐj
	generate
	genvar p;
		for (p=DDR2_DQS_DM_WIDTH-1; p>=0; p=p-1) begin: WRDATA_DQS_N
			FDDRRSE WRDATA_DDR2_DQS (
				.Q(dqs_n_out[p]),
				.D0(gnd),	// DQSDO,D1t
				.D1(vcc),
				.C0(clk90),
				.C1(clk270),
				.CE(vcc),
				.R(dqs_reset_d3d[p]),
				.S(gnd)
			);
		end
	endgenerate
	
	// inferr the 3-State buffer
	always @ * begin :Ddr_Dqs_N_Gen_Loop
		integer k;
		
		for (k=DDR2_DQS_DM_WIDTH-1; k>=0; k=k-1) begin
			if (dqs_tri_enable_d3dx[k]==1'b1) // o̓Cl[uDQSƓ
				ddr2_dqs_n[k] <= 1'bZ;
			else
				ddr2_dqs_n[k] <= dqs_n_out[k];
		end
	end
endmodule

